=== third_party/piet-gpu/Makefile ===
debug:
	cd ../externals/piet-gpu/pgpu-render && \
		cargo build --target-dir ../../../piet-gpu/out && \
		cd ../../../piet-gpu

release:
	cd ../externals/piet-gpu/pgpu-render && \
		cargo build --release --target-dir ../../../piet-gpu/out && \
		cd ../../../piet-gpu
